<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_product_typeCommunities extends JPlugin
{
	function plgJoomsuite_product_typeCommunities( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'communities') return;
		$pt_file = JPATH_ROOT.DS.'components/com_community/community.php';
		if(!file_exists($pt_file))
		{
			$out = 'This feature will work only if
			<a href="http://www.mightyextensions.com/joomla-components/peopletouch-community-social-network-service" target="_blank">Mighty Touch</a> is installed';
		}
		else
		{
			$aid = $obj->record_id;
			require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');

			$secid = ResHelper::getArticleSection($aid);
			if(!$secid)
			$secid = $params->get('section_id');

			if(!$secid)
			{
				echo JText::_('This field settings will be available after Sourse Section is selected in field plugin configuration');
				return;
			}
			$CP = ResHelper::getSectionParams($secid);

			if($CP->get('comm_enabled'))
			{
				$uid = false;
				$db = &JFactory::getDBO();

				if($cid = JRequest::getVar('cid'))
				{
					$query = " SELECT user_id FROM #__js_res_record WHERE id='$aid'";
					$db->setQuery( $query);
					$uid = $db->loadResult();
				}
				if(!$uid)
				{
					$user   =& JFactory::getUser();
					$uid = $user->get('id');
				}

				$sql = "SELECT * FROM #__community_communities WHERE published = '1'".($CP->get('comm_multi_seller') ? " AND user_id = '{$uid}'" : '');
				$db->setQuery($sql);
				if($groups = $db->loadObjectList())
				{
					$opt = array();
					$opt[] = JHTML::_('select.option', '0', '- '.JText::_('None').' -');
					foreach($groups as $group)
					{
						$opt[] = JHTML::_('select.option', $group->id, $group->title);
					}

					$obj->communities = isset($obj->communities) ? explode(",", $obj->communities ) : '';

					$out = JHTML::_('select.genericlist', $opt, 'pparams['.$obj->id.'][communities][]', 'class="inputbox"  multiple width="100%" size="'.count($opt).'"', 'value', 'text', $obj->communities );
				}
				else
				$out = JText::_('This is no created or published groups').'. '.JText::_('You can create them').'
			 <a href="'.JURI::root().'index.php?option=com_community&view=groups'.(JRequest::getInt('Itemid') ? '&Itemid='.JRequest::getInt('Itemid') :'').'" target="_blank">'.JText::_('here').'.</a>';
			}
			else
			$out = JText::_('Selected Sourse section is not Commercial. Please resave type plugin configurations or set up Commerce configurations in selected Section');
		}
		echo $out;
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'communities') return;
		if(!$value) return;
		$pt_file = JPATH_ROOT.DS.'components/com_community/community.php';
		if(!file_exists($pt_file)) return;

		$db = &JFactory::getDBO();
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		if($type != 'communities') return;
		if(!$field) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		
		$pt_file = JPATH_ROOT.DS.'components/com_community/community.php';
		if(file_exists($pt_file) && $params->get('show_communities'))
		{
			$val = explode('=', $field->value);
			if(isset($val[1]) && $val[1])
			{
				$out =  JText::_("Purchasing this product you will be joined to communities").': <ul>';
				$groups = $this->getCommunities($val[1]);
				foreach($groups as $group)
				{
					$out .= '<li><a href="index.php?option=com_community&&view=groups&layout=group&id='.$group->id.'&Itemid='.JRequest::getInt('Itemid').'"
									target="_blank">
									'.$group->title.'
								</a></li>';
				}
				$out .= '</ul>';
			}
		}
	}

	function onAfterSuccessOrder($type, $order_id, $product_id, $field_id, $value, $user_id, $amount)
	{
		if($type != 'communities') return;
		if($value == '') return;

		$pt_file = JPATH_ROOT.DS.'components/com_community/community.php';
		if(file_exists($pt_file) && $user_id)
		{
			$db = & Jfactory::getDBO();
			$val = explode("=", $value);
			if(isset($val[1]))
			{
				$groups = explode(",", $val[1]);
				$sql ="SELECT id FROM #__community_communities WHERE user_id = '$user_id' AND published = '1'";
				$db->setQuery($sql);
				$ccgroups = $db->loadResultArray();
				$groups = array_diff($groups, $ccgroups);
				if(count($groups))
				{
					$sql = "SELECT group_id	FROM #__community_user_mapping WHERE user_id = '$user_id' AND group_id IN (".implode(",", $groups).")
					AND user_block = '0' AND pending = '0'";
					$db->setQuery($sql);
					if($ugroups = $db->loadResultArray())
					{
						$groups = array_diff($groups, $ugroups);
					}
					if(count($groups))
					{
						foreach($groups as $group)
						{
							$sql = "INSERT INTO #__community_user_mapping
							(`id`, `user_id`, `group_id`, `user_block`, `ctime`, `access_type`, `pending`, `message`)
							VALUES
							('', '$user_id', '$group', '0', NOW(), '0', '0', '')";
							$db->setQuery($sql);
							$db->query();
							$sql = "UPDATE #__community_communities SET `num_users` = `num_users` + 1 WHERE `id` = {$group_id} ";
							$db->setQuery($sql);
							$db->query();
						}
					}
				}
			}
		}
	}

	function onOrderHistoryPrint($type, $order_id, $product_id, $value, $final_status, $user_id, $params)
	{
		if($type != 'communities') return;
		if($value == '') return;

		$out = '';
		$pt_file = JPATH_ROOT.DS.'components/com_community/community.php';
		if(file_exists($pt_file) && $user_id)
		{
			$db = & Jfactory::getDBO();
			$val = explode("=", $value);
			if(isset($val[1]))
			{
				$groups = $this->getCommunities($val[1]);
				$print = array();
				foreach($groups as $group)
				{
					$print[] = '<a href="index.php?option=com_community&&view=groups&layout=group&id='.$group->id.'&Itemid='.JRequest::getInt('Itemid').'"
									target="_blank">'.$group->title.'</a>';
				}
				$out = JText::_("You have been joined to communities").': '.implode(', ', $print);
				
			}
		}
		return $out;
	}

	function getCommunities($ids)
	{
		$db = & JFactory::getDBO();
		$sql = "SELECT id, title FROM #__community_communities WHERE id IN ( $ids )";
		$db->setQuery($sql);
		return $db->loadObjectList();
	}


}
?>